(defun c:blaetter( / bl ll as i lay b1 b2 l1 e pos)
  (setq ll (getlaylist))
  (setq bl (length ll))  
  (setq as (ssget "X" '((0 . "INSERT") (2 . "BLTTER"))))
  
  (setq j1 as)
  (if (or (= (- (sslength as) 1) (length ll))
	  (= (sslength as) (length ll))
      )	  
    (progn
      (setq i 0)
      (while (setq e (ssname as i))		
	(setq lay (cdr (assoc 410 (entget e))))	
        (if (/= 0 (setq pos (findpos ll lay)))
	  (progn	   
	    (setq b1 (cons "BLATT" (itoa pos)))	    
	    (setq b2 (cons "VBLATT" (itoa bl)))
	    (setq l1 (list b1 b2))	    	    
	    (setattrlst e l1 T)	    
	  )  
	)	
	(setq i (1+ i))	
      )	
    )
    (progn
      (princ "\nAnzahl der Blcke und Layouts ist unterschiedlich\n")
    )  
  )
  'Danke
)


(defun findpos(ll w / i n)
  (setq i 0)
  (if (assoc w ll)
    (progn
      (setq n (nth i ll))
      (while (and (< i (length ll)) (/= (car n) w))
        (setq i (1+ i))
        (setq n (nth i ll))
      )
    )  
  )
  (+ i 1)
)  
	       
(defun getlaylist( / z ll di n layname layent)
  (setq ll nil z 0)
  (setq di (namedobjdict))
  (setq di (dictsearch di "ACAD_LAYOUT"))
  (foreach n di
    (if (= (car n) 3)
      (progn
	(setq layname (cdr n))
	(if (/= layname "Model")
	  (setq z 1)
	)  
      )
    )
    (if (and (= z 1) (= (car n) 350))
      (progn
	(setq layent (cdr n))
	(setq ll (cons (cons layname layent)  ll))
	(setq z 0)
      )
    )  
  )
  (reverse ll)
)

(defun setattrlst(e attrlst fehler / el en bl attr)
  (setq el (entget e))
  ;* Wenn es sich um einen Block handelt
  (if (and (= (cdr (assoc 0 el)) "INSERT")
           (assoc 66 el)
      )
    (progn
      ;* Variablen initialisieren
      (setq en e)
      (while (and (setq en (entnext en))
                  (/= (cdr (assoc 0 (entget en))) "SEQEND")
             )
        (setq bl (entget en))
        (if (= (cdr (assoc 0 bl)) "ATTRIB")
          (progn
            (setq attr (cdr (assoc 2 bl)))                             
            (if (assoc attr attrlst)
              (progn	
                (setq bl (subst (cons 1 (cdr (assoc attr attrlst))) (assoc 1 bl) bl))
                (entmod bl)
              )
              (progn
                (if fehler
                  (princ (strcat "Attribut \"" attr "\" nicht gefunden!\n"))
                )
              )
            )
          )
        )
      )
    )
  )
  (entupd e)
)

(princ "\nProgrammaufruf mit BLAETTER in der Befehlszeile")'!

